
function $ce(tag, s) {
	if (!tag) return null;

	var o = document.createElement(tag);
	for (i in s) {
		o.style[i] = s[i];
	}

	return o;
}

function getTextStyle(o){
	return { fontSize: o.style.fontSize, fontFamily: o.style.fontFamily, fontWeight: o.style.fontFamily };
}


function makeTextSize(style, appendTo){
	style = Object.extend(style, {border: 'solid 0px red', visibility: 'hidden', position: 'absolute', top: 0, left: 0});
	var div = $ce('div', style);
	appendTo.appendChild(div);
	return div;
}
function getTextSize(text, o){
	o.innerHTML = text.escapeHTML().replace(/ /g, '&nbsp;');
	return o.offsetWidth;
}

	
var Crumb = {
	go: function(name, root){
		var p = $(name);
		var tag = p.innerHTML.unescapeHTML();
		var o = $ce('input');
		Object.extend(o, {
			originalValue: tag, 
			value: tag,
			root: root || '/tag/',
			onblur: Crumb.blur, 
			onfocus: Crumb.focus, 
			onmouseover: Crumb.mouseover, 
			onmouseout: Crumb.mouseout,
			onkeyup: Crumb.keyhandler, 
			onkeypress: Crumb.keyhandler
		});
		Object.extend(o, Element);
		p.innerHTML = ''; 
		p.appendChild(o);
		Crumb.sizer = makeTextSize(getTextStyle(o), p);
		o.style.width = getTextSize(tag, Crumb.sizer) + 40 + 'px';
	},
	mouseover: function() { this.addClassName(this, 'crumb-focus') },
	mouseout: function() { if(!this.focused) this.removeClassName(this, 'crumb-focus') },
	focus: function() { this.focused = true; this.addClassName(this, 'crumb-focus') },
	blur: function() {
		if (this.submitting) return false;
		this.focused = false;
		this.value = this.originalValue;
		this.removeClassName(this, 'crumb-focus')
		this.style.width = getTextSize(this.value, Crumb.sizer) + 40 + 'px'
	},

	keyhandler: function(e) { 
		e = e||window.event;
		if (e.type == 'keypress' && e.keyCode == 13) {
			var tag = this.value.replace(/ +/g, '+');
			if (tag) {
				this.submitting = true;
				location.href = this.root + encodeURIComponent(tag);
			}
		}
		this.style.width = getTextSize(this.value, Crumb.sizer) + 40 + 'px';
	}
}

